"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const errors_1 = require("../errors");
class Region {
    constructor(code) {
        this.setCode(code);
    }
    setCode(code) {
        this.checkCode(code);
        this._code = code;
    }
    checkCode(code) {
        const regexp = /^[0-2]{1}[0-9]{1}[0-9]{2}$/;
        const isCodeValid = regexp.test(code);
        if (!isCodeValid) {
            errors_1.WrongProvinceCode.throwBecauseOf(code);
        }
    }
    /**
     * Obtener código
     */
    value() {
        return this._code;
    }
    /**
     * Obtener código de departamento
     */
    getRegionCode() {
        return this.value().substr(0, 2);
    }
    static of(code) {
        return new this(code);
    }
}
exports.default = Region;
