"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _1 = require(".");
class Ubigeo {
    constructor(district) {
        this._district = district;
    }
    getProvince() {
        return this._district.getProvince();
    }
    getRegion() {
        return this.getProvince().getRegion();
    }
    /**
     * Obtener el nombre del distrito
     */
    get district() {
        return this._district.getName();
    }
    /**
     * Obtener el nombre de la provincia
     */
    get province() {
        const province = this.getProvince();
        return province.getName();
    }
    /**
     * Obtener el nombre del departamento
     */
    get region() {
        const region = this.getRegion();
        return region.getName();
    }
    /**
     * Obtener el código de ubigeo
     */
    get code() {
        return this._district.getCode();
    }
    /**
     * Crea instancia
     * @param code código de ubigeo
     */
    static code(code) {
        const district = _1.District.instance(code);
        return new this(district);
    }
    /**
     * Crea instancia
     * @param province nombre de provincia
     * @param district nombre de distrito
     */
    static location(province, district) {
        const newLocation = _1.Location.instance(province, district);
        const newDistrict = _1.District.instance(newLocation.ubigeo);
        return new this(newDistrict);
    }
    toString() {
        return `${this.region} - ${this.province} - ${this.district}`;
    }
}
exports.default = Ubigeo;
